"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var base_1 = require("./base");
function onCommit(map) {
    var _this = this;
    return base_1.default(function (resolver, request, schema) { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        var info, mapped, commits, errors, response, counter;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!request.commits) return [3 /*break*/, 2];
                    return [4 /*yield*/, resolver(request)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    request.context = request.context || {};
                    info = { schema: schema, context: request.context };
                    mapped = [];
                    commits = [];
                    return [4 /*yield*/, Promise.all(request.commits.map(function (commit) { return __awaiter(_this, void 0, void 0, function () {
                            var result_1, error_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, map(commit, info)];
                                    case 1:
                                        result_1 = _a.sent();
                                        if (result_1) {
                                            utils_1.mapData(result_1, function (record, type, id) {
                                                if (!record) {
                                                    delete result_1[type][id];
                                                }
                                                else {
                                                    Object.keys(record).forEach(function (f) {
                                                        if (record[f] === undefined)
                                                            delete record[f];
                                                    });
                                                }
                                            });
                                            mapped.push(result_1);
                                            commits.push(utils_1.merge(commit, result_1, 2));
                                        }
                                        else {
                                            commits.push(commit);
                                        }
                                        return [2 /*return*/, null];
                                    case 2:
                                        error_1 = _a.sent();
                                        return [2 /*return*/, error_1.message];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 3:
                    errors = _a.sent();
                    return [4 /*yield*/, resolver(__assign({}, request, { commits: commits }))];
                case 4:
                    response = _a.sent();
                    mapped.forEach(function (records, i) {
                        if (!response.errors[i]) {
                            utils_1.mapData(records, function (record, type, id) {
                                response.data[type] = response.data[type] || {};
                                utils_1.mergeRecord(response.data[type], utils_1.getId(id, response.newIds[type]), record);
                            });
                        }
                    });
                    counter = 0;
                    return [2 /*return*/, __assign({}, response, { errors: errors.map(function (error) {
                                return typeof error === 'string' ? error : response.errors[counter++];
                            }) })];
            }
        });
    }); });
}
exports.default = onCommit;
