"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
function setState(store, state, data, schema, changes) {
    var setChanged = function (type, id, field) {
        changes[type] = changes[type] || {};
        changes[type][id] = changes[type][id] || {};
        changes[type][id][field] = true;
    };
    try {
        for (var _a = __values(Object.keys(data)), _b = _a.next(); !_b.done; _b = _a.next()) {
            var type = _b.value;
            if (data[type] === undefined) {
                if (store === 'client') {
                    try {
                        for (var _c = __values(Object.keys(state.client[type] || {})), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var id = _d.value;
                            try {
                                for (var _e = __values(Object.keys(state.client[type][id] || {})), _f = _e.next(); !_f.done; _f = _e.next()) {
                                    var field = _f.value;
                                    if (!utils_1.isEqual(utils_1.get(state.combined, [type, id, field]), utils_1.get(state.server, [type, id, field]))) {
                                        setChanged(type, id, field);
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_f && !_f.done && (_g = _e.return)) _g.call(_e);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_h = _c.return)) _h.call(_c);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    delete state.client[type];
                    if (!state.server[type])
                        delete state.combined[type];
                    else
                        state.combined[type] = utils_1.clone(state.server[type], 1);
                    delete state.diff[type];
                }
            }
            else {
                state[store][type] = state[store][type] || {};
                state.combined[type] = state.combined[type] || {};
                state.diff[type] = state.diff[type] || {};
                try {
                    for (var _j = __values(Object.keys(data[type])), _k = _j.next(); !_k.done; _k = _j.next()) {
                        var id = _k.value;
                        if (data[type][id] === undefined ||
                            (data[type][id] === null && utils_1.isNewId(id))) {
                            if (store === 'client') {
                                try {
                                    for (var _l = __values(Object.keys(state.client[type][id] || {})), _m = _l.next(); !_m.done; _m = _l.next()) {
                                        var field = _m.value;
                                        if (!utils_1.isEqual(utils_1.get(state.combined, [type, id, field]), utils_1.get(state.server, [type, id, field]))) {
                                            setChanged(type, id, field);
                                        }
                                    }
                                }
                                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                                finally {
                                    try {
                                        if (_m && !_m.done && (_o = _l.return)) _o.call(_l);
                                    }
                                    finally { if (e_3) throw e_3.error; }
                                }
                                delete state.client[type][id];
                                if (!utils_1.get(state.server, [type, id]))
                                    delete state.combined[type][id];
                                else
                                    state.combined[type][id] = utils_1.clone(state.server[type][id], 0);
                                delete state.diff[type][id];
                            }
                        }
                        else if (data[type][id] === null) {
                            if (store === 'client') {
                                try {
                                    for (var _p = __values(Object.keys(state.combined[type][id] || {})), _q = _p.next(); !_q.done; _q = _p.next()) {
                                        var field = _q.value;
                                        setChanged(type, id, field);
                                    }
                                }
                                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                                finally {
                                    try {
                                        if (_q && !_q.done && (_r = _p.return)) _r.call(_p);
                                    }
                                    finally { if (e_4) throw e_4.error; }
                                }
                                state.client[type][id] = null;
                                delete state.combined[type][id];
                                state.diff[type][id] = -1;
                            }
                            else {
                                try {
                                    for (var _s = __values(Object.keys(state.combined[type][id] || {})), _t = _s.next(); !_t.done; _t = _s.next()) {
                                        var field = _t.value;
                                        if (!utils_1.isEqual(utils_1.get(state.combined, [type, id, field]), utils_1.get(state.client, [type, id, field]))) {
                                            setChanged(type, id, field);
                                        }
                                    }
                                }
                                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                                finally {
                                    try {
                                        if (_t && !_t.done && (_u = _s.return)) _u.call(_s);
                                    }
                                    finally { if (e_5) throw e_5.error; }
                                }
                                delete state.server[type][id];
                                if (!utils_1.get(state.client, [type, id])) {
                                    delete state.combined[type][id];
                                }
                                else {
                                    state.combined[type][id] = utils_1.clone(state.client[type][id], 0);
                                    state.diff[type][id] = 0;
                                }
                            }
                        }
                        else {
                            state[store][type][id] = state[store][type][id] || {};
                            if (utils_1.get(state.client, [type, id]) !== null) {
                                state.combined[type][id] = state.combined[type][id] || {};
                            }
                            try {
                                for (var _v = __values(Object.keys(data[type][id])), _w = _v.next(); !_w.done; _w = _v.next()) {
                                    var field = _w.value;
                                    var prev = utils_1.get(state.combined, [type, id, field]);
                                    var value = data[type][id][field];
                                    var f = schema[type][field];
                                    if (f.isList && value && value.length === 0)
                                        value = null;
                                    if (store === 'client') {
                                        state[store][type][id] = state[store][type][id] || {};
                                        state.combined[type][id] = state.combined[type][id] || {};
                                        if (data[type][id][field] === undefined) {
                                            delete state.client[type][id][field];
                                            if (utils_1.get(state.server, [type, id, field]) !== undefined) {
                                                state.combined[type][id][field] = state.server[type][id][field];
                                            }
                                            else {
                                                delete state.combined[type][id][field];
                                            }
                                            if (Object.keys(state.client[type][id]).length === 0) {
                                                delete state.client[type][id];
                                            }
                                            if (Object.keys(state.combined[type][id]).length === 0) {
                                                delete state.combined[type][id];
                                            }
                                        }
                                        else {
                                            state.client[type][id][field] = data[type][id][field];
                                            state.combined[type][id][field] = data[type][id][field];
                                        }
                                    }
                                    else {
                                        if (utils_1.get(state.client, [type, id]) !== null &&
                                            utils_1.get(state.client, [type, id, field]) === undefined) {
                                            state.combined[type][id][field] = value;
                                        }
                                        state.server[type][id][field] = value;
                                    }
                                    if (!utils_1.isEqual(utils_1.get(state.combined, [type, id, field]), prev)) {
                                        setChanged(type, id, field);
                                    }
                                }
                            }
                            catch (e_6_1) { e_6 = { error: e_6_1 }; }
                            finally {
                                try {
                                    if (_w && !_w.done && (_x = _v.return)) _x.call(_v);
                                }
                                finally { if (e_6) throw e_6.error; }
                            }
                            if (utils_1.get(state.client, [type, id]) === undefined) {
                                delete state.diff[type][id];
                            }
                            else if (utils_1.get(state.client, [type, id])) {
                                state.diff[type][id] = utils_1.isNewId(id) ? 1 : 0;
                            }
                        }
                    }
                }
                catch (e_7_1) { e_7 = { error: e_7_1 }; }
                finally {
                    try {
                        if (_k && !_k.done && (_y = _j.return)) _y.call(_j);
                    }
                    finally { if (e_7) throw e_7.error; }
                }
            }
        }
    }
    catch (e_8_1) { e_8 = { error: e_8_1 }; }
    finally {
        try {
            if (_b && !_b.done && (_z = _a.return)) _z.call(_a);
        }
        finally { if (e_8) throw e_8.error; }
    }
    var e_8, _z, e_2, _h, e_1, _g, e_7, _y, e_3, _o, e_4, _r, e_5, _u, e_6, _x;
}
exports.default = setState;
